 ###########################################################################
 #            Copyright (C) 2006 SafeNet, Inc.                             #
 #                   All Rights Reserved                                   #
 #                                                                         #
 #         This install sentinel keys Protection  version 1.0.2            #
 #                                                                         #
 ###########################################################################
#!/bin/sh
PACKAGE_DIR=/opt/safenet_sentinel
PRODUCT_NAME_DIR=sentinel_keys
PRODUCT_NAME=Sentinel\ Keys
PRODUCT_VER=102
NAME_SEP=_
MAJOR=1
MINOR=0
REV=2
version=1.0.2
spi_version=1.0.2
sud_version=7.3.0
srv_version=1.0.2
SRV_VER=102
SUD_VER=730
SPI_VER=102
SUD_RPM=sntl-sud
SERVER_RPM=shk-server
SPI_RPM=shk-skpi
SPI_INSTALL_DIR=/opt/safenet_sentinel/sentinel_keys/1.0/sentinel_keys_protection_installer
sntl_product_info=/var/opt/sentinel_keys/shk_product.info
old_sntl_product_info=/var/opt/sentinel/sntl_product.info
RELEASE_DATE=0612
################################################################################
#			Status Info
################################################################################
statusinfo()
{

		 echo $line
                 echo "         Type \"y\" to overwrite the older version of the Sentinel System Driver (daemon) found on this system."
                 echo "         Do not cancel the upgrade before the installation has completed or you may not be able to run applications"
                 echo "         that depend on the software components being installed.                                   "
                 echo "                                                                                                                 "
                 echo "         Type \"n\" to cancel this installation without upgrading the Sentinel System Driver (daemon) existing"
                 echo "         on this system"
                 echo $line

        IsContinue="a"
        while [ "$IsContinue" != "n" -o "$IsContinue" != "y" ]
        do
		echo -n "      Enter your choice (y/n): "
                read -r IsContinue
                if [ "$IsContinue" == "n" ]
                then
                        echo "Installer Aborted by User"
                        exit
                elif [ "$IsContinue" == "y" ]
                then
                        break
                else
                        IsContinue="a"
                fi
        done
}

#################################################################################
clear
line="-------------------------------------------------------------------------------"
showlicense()
{
if [ $LicenseSHOW == 0 ]
then
    echo $line
    [ -f $LicensePATH/licenseagreement.txt ] 
    if [ $? == 0 ] 
    then
    more $LicensePATH/licenseagreement.txt
    while [ 1 ]
    do 
      echo -n "Do you Agree with the License(y/n): "
      read -r choice
      case $choice in 
        'y')
        break 2
        ;;
        'Y') 
        break 2
        ;;
        'n') 
        exit
        ;;
        'N') 
        exit
        ;;
        *)
        echo "-------------------------------------------------------------------------------"
    ;;
        esac
        done
    else
    echo "\"licenseagreement.txt\" file missing."
    echo $line
    exit
    fi
fi
}

###############################################################################
#                      Check for Dependencies
###############################################################################
check_dep()
{
#check for root
user_id=`id -u`
if [ $user_id -ne 0 ]
then
    echo "ERROR:To Install this software make sure you have Super User (root) permission."  
    echo "Installation Aborted."
    exit
fi

}

#############################################################################################################
errchecking(){
    if [ $? = 0 ]
        then
            echo "$Package installation was successful."
            echo $line
        else
            echo "$Package installation failed."
            echo "WARNING:To install this software make sure that you have Super user (root) permissions." 
            echo $line
        exit
    fi
}

#############################################################################################################

check_daemon()
{

SHK_DEMON_RET=0
OLD_DEMON_RET=0
[ -f "$sntl_product_info" ]
        if [ $? -eq 0 ]
        then
                SHK_DEMON_VER=`grep sud $sntl_product_info|cut -d = -f 2|cut -d : -f 2`
        if [ -z $SHK_DEMON_VER ]
        then
                        SHK_DEMON_RET=0 #No SHK SUD 7.3.0 exist
        else
                        if [ $SHK_DEMON_VER -le $SUD_VER ]
                        then
                                SHK_DEMON_RET=1  # SUD 7.3.0 DEMON version exist
                        else
                                #Higher DEMON version already installed. Do Nothing & exit
                                SHK_DEMON_RET=3 #> SUD 7.3.0 DEMON version exist
                                echo -e "\n ERROR:Installer has detected a higher version of Sentinel USB Daemon on your system"
                                exit 1
                        fi
        fi
        fi

#Check for old SSP/SUP product existence
#check for ssp630
                rpm -q ssp630 > /dev/null 2>&1
                if [ $? -eq 0 ]
                then
                        # ssp630 found
            OLD_DEMON_RET=1
                fi
#check for ssp631
                rpm -q ssp631 > /dev/null 2>&1
                if [ $? -eq 0 ]
                then
                        # ssp631 found
                        OLD_DEMON_RET=1
                fi
#check for ssp700
        rpm -q SSP-Toolkit-RH9 > /dev/null 2>&1
                if [ $? -eq 0 ]
                then
                        # ssp700 found
                        OLD_DEMON_RET=1
                fi
#check for SUP
tmp_var_ins=0
                if [ -f "$old_sntl_product_info" ]
                then
                        tmp_var_ins=`grep -c sud $old_sntl_product_info|cut -d : -f 4`
                        if [ $tmp_var_ins -eq 1 ]
                        then
                                OLD_DEMON_RET=1
                        fi
		fi

}


###############################################################################
ask()
{
    echo $line
    choice=-1
    while [ "$choice" != "1" ] && [ "$choice" != "2" ] && [ "$choice" != "0" ]
    do
        echo "   1 : Install only SUD            "
        echo "   2 : Install both Server and SUD "
        echo "   0 : Exit                        "    
        echo -n "Please enter your choice: "
        read -r choice
    done
    echo $line
}

###############################################################################
copy_uninstall() 
{
    #Copy the Unistall script
    install -D -o root -g root -m 755 skpi_uninstall.sh $SPI_INSTALL_DIR/english/skpi_uninstall.sh
    FILESTAMP=$RELEASE_DATE"0$MAJOR$MINOR$MINOR.20"
    find $SPI_INSTALL_DIR/english/skpi_uninstall.sh -exec touch -t $FILESTAMP {} \;

    #FILESTAMP=$RELEASE_DATE"0$SPI_VER.00";
    #touch  -t $FILESTAMP $PACKAGE_DIR/$PRODUCT_NAME_DIR/$MAJOR.$MINOR/skpi_uninstall.sh;
    #) > /dev/null 2>&1
}
###############################################################################
                        # Show SHK Banner
###############################################################################
showbanner()
{
echo $line
echo "                Sentinel Keys Protection Installer $spi_version Installation Script"
echo "                           Copyright (C) 2006 SafeNet, Inc."
echo "                               All rights reserved."
echo $line
echo "This script will install                     "
echo "    - Sentinel USB Daemon $sud_version"
echo "    - Sentinel Keys Server $srv_version (Optional)"
}


##########################################################################################
#                      START HERE
##########################################################################################
clear
line="-------------------------------------------------------------------------------"
LicensePATH=.
LicenseSHOW=0
ret=0
Package=""
showlicense
showbanner
LicenseSHOW=1
export LicenseSHOW
choice=-1
ret=0
val=0

check_dep
check_daemon

    if [ $OLD_DEMON_RET -eq 1 ] && [ $SHK_DEMON_RET -ne 1 ]
    then
        statusinfo
    fi    
	ask
        if [ "$choice" == "0" ]
        then
                exit
        elif [ "$choice" == "1" ]
        then
                cd ./sentinel_usb_daemon
                sh sud_install.sh nobanner
                cd ..
        elif [ "$choice" == "2" ]
        then
                ####  Daemon installation
                cd ./sentinel_usb_daemon
                sh sud_install.sh nobanner
                cd ..

                ###### Server installation
                echo "Installing Sentinel Keys Server"
                rpm --force -ivh "server/$SERVER_RPM-$srv_version-0.i386.rpm"
        fi

# Copy Web Help and Readme.pdf
rpm -q $SPI_RPM-$version > /dev/null 2>&1
if [ $? -ne 0 ] ; then     # No need to copy if spi rpm is installed.
    mkdir -p    $SPI_INSTALL_DIR/english/help    > /dev/null 2>&1
    install -D -m 644  ./ReadMe.pdf  $SPI_INSTALL_DIR/english/help/ReadMe.pdf > /dev/null 2>&1
    copy_uninstall
    #FILESTAMP=$RELEASE_DATE"0$SPI_VER.00";
    FILESTAMP=$RELEASE_DATE"0$MAJOR$MINOR$MINOR.20"
    find $SPI_INSTALL_DIR -exec touch -t $FILESTAMP {} \;
    FILESTAMP=$RELEASE_DATE"0$MAJOR$MINOR$MINOR.20";
fi

